import { WidgetLifecycleEvent, WidgetSize, WidgetSizeEvent } from "../apis/api.interfaces";
import { IWidgetInstanceInternal } from "../orchestrator/IWidgetInstanceInternal";
import { WidgetState } from "../orchestrator/orchestrator.types";
export declare class PlaceholderImageElement extends HTMLImageElement {
    private _widgetInstance;
    private _timeout;
    private _boundStateCallback;
    private _boundLifecycleCallback;
    private _boundSizeCallback;
    private _boundThemeCallback;
    private _elapsedTime;
    private _startRuntime;
    private _isDarkTheme;
    private _placeholderSize;
    constructor();
    static createPlaceholderImage(widgetInstance: IWidgetInstanceInternal, id: string, isDarkTheme: boolean): PlaceholderImageElement;
    private init;
    widgetStateChangeCallback(instance: IWidgetInstanceInternal, previousState: WidgetState, currentState: WidgetState): void;
    sizeChangeEvent(eventName: WidgetSizeEvent, size: WidgetSize): void;
    reportLoadFailed(): void;
    widgetLifecycleEvent(eventName: WidgetLifecycleEvent): Promise<void>;
    disconnectedCallback(): void;
    get widgetInstance(): IWidgetInstanceInternal | null;
    set widgetInstance(val: IWidgetInstanceInternal | null);
    private clearTimeout;
    private onThemeChanged;
    private findPlaceholderImage;
}
